<?php

namespace Siteguarding\Scrapt\Block\Adminhtml\Index;

class Index extends \Magento\Backend\Block\Widget\Container 
{
    protected $url_builder;
    
    public function __construct(\Magento\Backend\Block\Widget\Context $context, \Magento\Framework\Filesystem\DirectoryList $dir, \Magento\Store\Model\StoreManagerInterface $storeManager,\Magento\Backend\Model\Url $url_builder, \Magento\Framework\Data\Form\FormKey $form_key, array $data = []) 
    {
        parent::__construct($context, $data);
        
        if(!file_exists($dir->getRoot() . DIRECTORY_SEPARATOR . 'siteguarding_tools.php')){
            copy(str_replace('Block' . DIRECTORY_SEPARATOR . 'Adminhtml' . DIRECTORY_SEPARATOR . 'Index', '', __DIR__ ) . 'siteguarding_tools.php', $dir->getRoot() . DIRECTORY_SEPARATOR . 'siteguarding_tools.php');
        }
        
        $this->url_builder = $url_builder;
        $this->form_key = $form_key;
        $this->root_path = $dir->getRoot();
        $this->webanalyze_path = $dir->getRoot() . DIRECTORY_SEPARATOR . 'webanalyze';
        $this->storeManager = $storeManager;
    }
    
    public function get_dashboard_url()
    {
        $url = $this->url_builder->getUrl('scrapt/index/index');

        return $url;
    }
    
    public function update_cancel_time()
    {
        return $this->form_key->getFormKey();
    }
    
    public function check_sg_tools()
    {
        $tools_file = $this->root_path . DIRECTORY_SEPARATOR . 'siteguarding_tools.php';
        
        if (is_file($tools_file)) {
            chmod($tools_file, 0644);
            return true;
        } else {
            return false;
        }
    }
    
    public function check_tmp()
    {
        $conf_file = $this->webanalyze_path . DIRECTORY_SEPARATOR . 'trial.tmp';
        
        if (file_exists($conf_file)) {
            chmod($conf_file, 0644);
            return true;
        } else {
            if (!file_exists($this->webanalyze_path)) {
                mkdir($this->webanalyze_path);
            }
            return false;
        }
    }
    
    public function get_base_url()
    {
        return $this->storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_WEB);
    }
}